local addonName, addon = ...

addon[1] = {} -- Gloable
addon[2] = {} -- Function
addon[3] = {} -- Config
addon[4] = {} -- Locale

local G, F, C, L = unpack(addon)

local events = {}

local host = CreateFrame("Frame")
host:SetScript("OnEvent", function(_, event, ...)
	for func in pairs(events[event]) do
		if event == "COMBAT_LOG_EVENT_UNFILTERED" then
			func(event, CombatLogGetCurrentEventInfo())
		else
			func(event, ...)
		end
	end
end)

function G:RegisterEvent(event, func, unit1, unit2)
	if not events[event] then
		events[event] = {}
		if unit1 then
			host:RegisterUnitEvent(event, unit1, unit2)
		else
			host:RegisterEvent(event)
		end
	end

	events[event][func] = true
end

function G:UnregisterEvent(event, func)
	local funcs = events[event]
	if funcs and funcs[func] then
		funcs[func] = nil

		if not next(funcs) then
			events[event] = nil
			host:UnregisterEvent(event)
		end
	end
end

local DefaultDB = {
	FirstUSE = true;
	cvar = true,
	dbm = true,
	exrt = true,
	skada = true,
	tiny = true,
	trufi = true,
	ui = true,
	chat = true,
	target = true,
	zu = true,
	comb = true,
	syd = true,
	icon = true,
	plate = true,
	arrow = true,
	unitf = true,
	cast = true,
	chatg = true,
	quest = true,
	smap = true,
	mmb = true,
	chatm = true,
	chatb = true,
	stop = true,
	ftip = 1,
	
}

local eventframe = CreateFrame("Frame")
eventframe:RegisterEvent("ADDON_LOADED")
eventframe:SetScript("OnEvent",function(self,_,addon)
	if addon ~= "AddUI" then return end
	if not AddUIDB then AddUIDB = {} end
	
		for i, j in pairs(DefaultDB) do
		if type(j) == "table" then
			if AddUIDB[i] == nil then AddUIDB[i] = {} end
			for k, v in pairs(j) do
				if AddUIDB[i][k] == nil then
					AddUIDB[i][k] = v
				end
			end
		else
			if AddUIDB[i] == nil then AddUIDB[i] = j end
		end
	end
	self:UnregisterAllEvents()

end)
local function TestFunc()
if AddUIDB["ceshi"] ==  true  then print("测试") end
end
G:RegisterEvent("PLAYER_LOGIN",TestFunc)

local frame = CreateFrame("Frame", nil, InterfaceOptionsFrame)
frame.name = addonName
frame:SetScript("OnShow", function(frame)

	local addui = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	addui:SetPoint("TOPLEFT", 55, -16)
	addui:SetText(addonName)
	addui:SetFont("fonts\\ARHei.ttf", 30, "OUTLINE")
	
	local sz = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	sz:SetPoint("TOPLEFT", 16, -56)
	sz:SetText("这是一个设置界面?")
	
	local sm = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	sm:SetPoint("TOPLEFT", 200, -22)
	sm:SetText("重载界面|cff00EE00/aa|r     打开此设置界面|cff00EE00/ad|r\n\n只是一个简单的开关界面,省的去改toc文件了\n|cffFFC0CB需要重载界面才能生效|r,或者退一次游戏\n右击聊天快捷条|cff00EE00世|r按钮可以加入/退出世界频道")
	sm:SetJustifyH("LEFT")
	
	local qqun = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	qqun:SetPoint("BOTTOMRIGHT", -10, 10)
	qqun:SetText("QQ群:718148969")
	qqun:SetJustifyH("RIGHT")
	
	local clear = CreateFrame("Button", "AddUISaveButton", frame, "UIPanelButtonTemplate")
	clear:SetText("重载界面")
	clear:SetWidth(177)
	clear:SetHeight(24)
	clear:SetPoint("TOPLEFT", 16, -85)
	clear.tooltipText = "重载界面"
	clear:SetScript("OnClick", function()
		ReloadUI()
	end)
	
	local function newCheckbox(label, description, onClick)
		local check = CreateFrame("CheckButton", "AddUICheck" .. label, frame, "InterfaceOptionsCheckButtonTemplate")
		check:SetScript("OnClick", function(self)
			local tick = self:GetChecked()
			onClick(self, tick and true or false)
		end)
		check.label = _G[check:GetName() .. "Text"]
		check.label:SetText(label)
		check.tooltipText = label
		check.tooltipRequirement = description
		return check
	end

	local cvarc = newCheckbox("CVar-锁定一些系统设定","CVar设定,比如滚动战斗记录自动勾选,最远视角等等",function(self, value) AddUIDB.cvar = value end)
	cvarc:SetChecked(AddUIDB.cvar)
	cvarc:SetPoint("TOPLEFT", 16, -120)

	local dbmc = newCheckbox("DBM-右侧计时条定位","包括语音包和提示音自动勾选,隐藏小地图按钮",function(self, value) AddUIDB.dbm = value end)
	dbmc:SetChecked(AddUIDB.dbm)
	dbmc:SetPoint("TOPLEFT", 16, -150)
	
	local exrtc = newCheckbox("ExRT-计时器.战复","勾去掉后/EXRT在计时器里面把战斗计时器的勾去掉就可以彻底关闭了",function(self, value) AddUIDB.exrt = value end)
	exrtc:SetChecked(AddUIDB.exrt)
	exrtc:SetPoint("TOPLEFT", 16, -180)
	
	local skadac = newCheckbox("Skada-位置定位","不仅仅是定位,还勾选了一些设置,比如进副本清除数据",function(self, value) AddUIDB.skada = value end)
	skadac:SetChecked(AddUIDB.skada)
	skadac:SetPoint("TOPLEFT", 16, -210)
	
	local tinyc = newCheckbox("TinyInspect勾选","每次上线自动勾选同一种配置,",function(self, value) AddUIDB.tiny = value end)
	tinyc:SetChecked(AddUIDB.tiny)
	tinyc:SetPoint("TOPLEFT", 16, -240)
	
	local trufic = newCheckbox("TrufiGCD自动配置","这个插件没自己装不用管这个,装了会自动设置,不喜欢再去掉",function(self, value) AddUIDB.trufi = value end)
	trufic:SetChecked(AddUIDB.trufi)
	trufic:SetPoint("TOPLEFT", 16, -270)
	
	local uic = newCheckbox("UI缩放锁定","ESC-系统-高级-最下面那个UI缩放",function(self, value) AddUIDB.ui = value end)
	uic:SetChecked(AddUIDB.ui)
	uic:SetPoint("TOPLEFT", 16, -300)
	
	local chatc = newCheckbox("聊天窗口位置锁定","每次上线重设聊天框位置",function(self, value) AddUIDB.chat = value end)
	chatc:SetChecked(AddUIDB.chat)
	chatc:SetPoint("TOPLEFT", 16, -330)
	
	local targetc = newCheckbox("目标头像位置锁定","给个开关满意了?不刷俩飞机意思意思?",function(self, value) AddUIDB.target = value end)
	targetc:SetChecked(AddUIDB.target)
	targetc:SetPoint("TOPLEFT", 16, -360)
	
	local zuc = newCheckbox("密语自动邀请","别人密你123或者.组.会自动邀请,支持战网密语",function(self, value) AddUIDB.zu = value end)
	zuc:SetChecked(AddUIDB.zu)
	zuc:SetPoint("TOPLEFT", 16, -390)
	
	local combc = newCheckbox("进入脱离战斗提示","屏幕中间上方那个进入脱离战斗提示",function(self, value) AddUIDB.comb = value end)
	combc:SetChecked(AddUIDB.comb)
	combc:SetPoint("TOPLEFT", 16, -420)
	
	local sydc = newCheckbox("角色面板耐久","C键面板装备栏下面的耐久度百分比",function(self, value) AddUIDB.syd = value end)
	sydc:SetChecked(AddUIDB.syd)
	sydc:SetPoint("TOPLEFT", 16, -450)
	
	local iconc = newCheckbox("目标标记按钮","目标头像右边的几个标记按钮",function(self, value) AddUIDB.icon = value end)
	iconc:SetChecked(AddUIDB.icon)
	iconc:SetPoint("TOPLEFT", 16, -480)
	
	local platec = newCheckbox("血条仇恨变色","血条仇恨变色,共生怪.易爆球.都会变,只能系统自带的血条用",function(self, value) AddUIDB.plate = value end)
	platec:SetChecked(AddUIDB.plate)
	platec:SetPoint("TOPLEFT", 16, -510)
	
	local arrowc = newCheckbox("血条右侧箭头","血条右侧的箭头指示",function(self, value) AddUIDB.arrow = value end)
	arrowc:SetChecked(AddUIDB.arrow)
	arrowc:SetPoint("TOPLEFT", 16, -540)
	
	local unitfc = newCheckbox("头像美化","头像美化和旁边的血量百分比",function(self, value) AddUIDB.unitf = value end)
	unitfc:SetChecked(AddUIDB.unitf)
	unitfc:SetPoint("TOPLEFT", 300, -120)
	
	local castc = newCheckbox("施法条美化","这个施法条是系统自带的去掉了边框放大了",function(self, value) AddUIDB.cast = value end)
	castc:SetChecked(AddUIDB.cast)
	castc:SetPoint("TOPLEFT", 300, -150)
	
	local questc = newCheckbox("任务栏美化","任务栏美化",function(self, value) AddUIDB.quest = value end)
	questc:SetChecked(AddUIDB.quest)
	questc:SetPoint("TOPLEFT", 300, -180)
	
	local smapc = newCheckbox("小地图美化","这个关掉的话需要重新进一次游戏才能正常",function(self, value) AddUIDB.smap = value end)
	smapc:SetChecked(AddUIDB.smap)
	smapc:SetPoint("TOPLEFT", 300, -210)
	
	local mmbc = newCheckbox("动作条美化","动作条美化",function(self, value) AddUIDB.mmb = value end)
	mmbc:SetChecked(AddUIDB.mmb)
	mmbc:SetPoint("TOPLEFT", 300, -240)
	
	local chatgc = newCheckbox("聊天过滤","过滤大部分广告还有部分公会收人",function(self, value) AddUIDB.chatg = value end)
	chatgc:SetChecked(AddUIDB.chatg)
	chatgc:SetPoint("TOPLEFT", 300, -270)
	
	local chatmc = newCheckbox("聊天窗口美化","聊天窗口美化",function(self, value) AddUIDB.chatm = value end)
	chatmc:SetChecked(AddUIDB.chatm)
	chatmc:SetPoint("TOPLEFT", 300, -300)
	
	local chatbc = newCheckbox("聊天快捷按钮","右击世可以快速加入世界频道!",function(self, value) AddUIDB.chatb = value end)
	chatbc:SetChecked(AddUIDB.chatb)
	chatbc:SetPoint("TOPLEFT", 300, -330)
	
	local stopc = newCheckbox("打断喊话","打断通报,小队会变小队通报,团队变团队通报",function(self, value) AddUIDB.stop = value end)
	stopc:SetChecked(AddUIDB.stop)
	stopc:SetPoint("TOPLEFT", 300, -360)

	local info = {}
	local TipDropdown = CreateFrame("Frame", "Tipcursor", frame, "UIDropDownMenuTemplate")
	TipDropdown:SetPoint("TOPLEFT", 290, -390)
	TipDropdown.initialize = function()
		wipe(info)
		local fonts = {1, 0, 2}
		local names = {"跟随", "不跟随", "非战斗跟随"}
		for i, font in next, fonts do
			info.text = names[i]
			info.value = font
			info.func = function(self)
				AddUIDB.ftip = self.value
				TipcursorText:SetText(self:GetText())
			end
			info.checked = font == AddUIDB.ftip
			UIDropDownMenu_AddButton(info)
		end
	end
	TipcursorText:SetText("鼠标跟随方式")
	
	frame:SetScript("OnShow", nil)
end)

InterfaceOptions_AddCategory(frame)
SLASH_ADDUI1 = "/ad"
SLASH_ADDUI2 = "/add"
SLASH_ADDUI3 = "/addui"
SlashCmdList["ADDUI"] = function() 
    InterfaceOptionsFrame_OpenToCategory(frame)
	InterfaceOptionsFrame_OpenToCategory(frame)
end